package ru.dbotthepony.mc.otm.config

object ServerConfig : AbstractConfig("misc") {
	val LABORATORY_LAMP_LIGHT_LENGTH: Int by builder.comment("In blocks").defineInRange("LABORATORY_LAMP_LIGHT_LENGTH", 6, 1, 128)
	val INFINITE_EXOSUIT_UPGRADES: Boolean by builder.comment("Allows to apply the same upgrade over and over again.", "Obviously completely breaks balance.").define("INFINITE_EXOSUIT_UPGRADES", false)

	init {
		builder.push("EXPERIENCE_CAPSULES")
	}

	val DROP_EXPERIENCE_CAPSULES: Boolean by builder
		.comment("Whenever to replace regular player experience drops with experience capsules")
		.comment("These capsules can be collected by gravestone mods, and are not limited in experience they can contain")
		.define("ENABLED", true)

	val MIN_EXPERIENCE_DROPPED: Double by builder
		.comment("Minimal percent of experience dropped on death into capsules")
		.defineInRange("MINIMAL_PERCENT", 0.4, 0.0, 1.0)

	val MAX_EXPERIENCE_DROPPED: Double by builder
		.comment("Maximal percent of experience dropped on death into capsules")
		.defineInRange("MAXIMAL_PERCENT", 0.8, 0.0, 1.0)

	init {
		builder.pop()
	}
}
