package ru.dbotthepony.mc.otm.data

import com.google.gson.JsonDeserializationContext
import com.google.gson.JsonObject
import com.google.gson.JsonSerializationContext
import com.google.gson.JsonSyntaxException
import com.mojang.serialization.Codec
import net.minecraft.world.level.storage.loot.Serializer
import ru.dbotthepony.mc.otm.core.fromJsonStrict
import ru.dbotthepony.mc.otm.core.set
import ru.dbotthepony.mc.otm.core.toJsonStrict

class Codec2Serializer<T : Any>(val codec: Codec<T>, val embed: Boolean = true) : Serializer<T> {
	override fun serialize(p_79325_: JsonObject, p_79326_: T, p_79327_: JsonSerializationContext) {
		if (embed) {
			val result = codec.toJsonStrict(p_79326_, p_79325_)

			if (result !is JsonObject) {
				throw RuntimeException("Expected JsonObject from codec, got ${result::class.qualifiedName}")
			}

			val keys = ArrayList(p_79325_.keySet())
			for (k in keys) p_79325_.remove(k)
			for ((k, v) in result.entrySet()) p_79325_[k] = v
		} else {
			p_79325_["value"] = codec.toJsonStrict(p_79326_)
		}
	}

	override fun deserialize(p_79323_: JsonObject, p_79324_: JsonDeserializationContext): T {
		if (embed) {
			return codec.fromJsonStrict(p_79323_)
		} else {
			return codec.fromJsonStrict(p_79323_["value"] ?: throw JsonSyntaxException("Missing 'value' element"))
		}
	}
}
